/* d_logic.h		-*- C++ -*-
 *$Header: /al/acs/src/RCS/d_logic.h,v 7.98 95/04/19 01:06:57 al Exp $
 * data structures and defaults for logic model.
 */
#define D_LOGIC_H

#ifndef E_ELEMNT_H
#include "e_elemnt.h"
#endif

#define PORTSPERGATE (10)

#define lNONE	(0)
#define	lAND	(1)
#define	lNAND	(2)
#define	lOR	(3)
#define	lNOR	(4)
#define	lXOR	(5)
#define lINV	(6)

#define lDEFAULT_modelname	"-error-"
#define lDEFAULT_type	(lINV)
#define lDEFAULT_delay	(1e-9)
#define lDEFAULT_rise	(lDEFAULT_delay/2.)
#define lDEFAULT_fall	(lDEFAULT_delay/2.)
#define lDEFAULT_rs	(1e2)
#define lDEFAULT_rw	(1e9)
#define lDEFAULT_th1	(.75)
#define lDEFAULT_th0	(.25)
#define lDEFAULT_mr	(5.)
#define lDEFAULT_mf	(5.)
#define lDEFAULT_over	(.1)
#define lDEFAULT_vmax	(5.)
#define lDEFAULT_vmin	(0.)
#define lDEFAULT_range	(5.)

struct lmod;

class DEV_LOGIC : public ELEMENT {
public:
	DEV_LOGIC();
	DEV_LOGIC(const DEV_LOGIC& p);
	CARD*	clone()const{return new DEV_LOGIC(*this);}
	void	parse(CS&);
 	void	print(int,int)const;
	double	probe_tr_num(const char*)const;
	double	probe_ac_num(const char*)const;
	void	expand();
	int	dotr();
	void	untr();
	void	doac();
	double	tr_review();
};

struct logic {
   generic_t	*x;
   size_t	ssize;
   const struct lmod *m;
   char 	modelname[LABELEN+1];
   node_t	n[PORTSPERGATE+1];	/* up to here must match subckt */
   					/* PORTSPERGATE <= PORTSPERSUBCKT */
   int		type;			/* and, or, etc. */
   unsigned	incount;		/* count input nodes */
   int		gatemode;
};

class MODEL_LOGIC : public CARD {
public:
	MODEL_LOGIC(const char *name = "");
	MODEL_LOGIC(const MODEL_LOGIC& p){assert(!"copy-model??");}
	CARD*	clone()const{return new MODEL_LOGIC(*this);}
	void	parse(CS&);
 	void	print(int,int)const;
};

struct lmod {
   generic_t	*x;
   size_t	ssize;
   double	delay;
   double	rise;
   double	fall;
   double	rs;
   double	rw;
   double	th1;
   double	th0;
   double	mr;
   double	mf;
   double	over;
   double	vmax;
   double	vmin;
   double	range;
};
