/* d_res.cc
 *$Header: /al/acs/src/RCS/d_res.cc,v 7.98 95/04/19 01:05:22 al Exp $
 * functions for resistor.
 * x = amps, y.f0 = volts, ev = y.f1 = ohms
 */
#include "ecah.h"
#include "error.h"
#include "u_option.h"
#include "d_res.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//	void	DEV_RESISTANCE::expand();
// 	int	DEV_RESISTANCE::dotr();
// 	void	DEV_RESISTANCE::doac();
/*--------------------------------------------------------------------------*/
void DEV_RESISTANCE::expand()
{
  if (val == 0.){
    error(bPICKY, "%s: short circuit\n", printlabel());
    y0.f1 = OPT::shortckt;
  }else{
    y0.f1 = val;
  }
  y0.f0 = LINEAR;
  m0.f1 = 1./y0.f1;
  m0.c0 = 0.;
  ev    = val;
  acg   = m0.f1;
  assert(loss == 0.);
}
/*--------------------------------------------------------------------------*/
int DEV_RESISTANCE::dotr()
{
  if (trfun){
    trsetup();
    m0.x = tr_volts_limited(&(n[OUT1]),&(n[OUT2]));
    y0.x = m0.c0 + m0.f1 * m0.x;
    (*trfun)(this);
    if (y0.f1 == 0.){
      error(bPICKY, "%s: short circuit\n", printlabel());
      y0.f1 = OPT::shortckt;
    }
    m0.f1 = 1./y0.f1;
    m0.c0 = y0.x - y0.f0 / y0.f1;
    trload_passive();
    return converged = conv_check();
  }else if (probes){
    trsetup();
    m0.x = tr_volts(&(n[OUT1]),&(n[OUT2]));
    y0.x = m0.c0 + m0.f1 * m0.x;
    y0.f0 = y0.x * y0.f1;
    assert(conchk(m0.f1, 1./y0.f1, OPT::abstol));
    assert(m0.c0 == 0.);
    trload_passive();
    return converged = YES;
  }else{
    assert(conchk(m0.f1, 1./y0.f1, OPT::abstol));
    assert(m0.c0 == 0.);
    trload_passive();
    return converged = YES;
  }
}
/*--------------------------------------------------------------------------*/
void DEV_RESISTANCE::doac()
{
  if (acfun){
    double dcvolts = dc_volts(&(n[OUT1]),&(n[OUT2]));
    acbias = m0.c0 + m0.f1*dcvolts;
    ev = (*acfun)(this);
    if (ev == 0.){
      error(bPICKY, "%s: short circuit\n", printlabel());
      ev = OPT::shortckt;
    }
    acg = 1. / ev;
  }else if (trfun){
    ev  = y0.f1;
    acg = 1. / y0.f1;
  }else{
    assert(acg == 1./y0.f1);
  }
  acload_passive();
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
