/* e_card3.c
 *$Header: /al/acs/src/RCS/e_card3.cc,v 7.98 95/04/19 01:05:38 al Exp $
 * Base class for "cards" in the circuit description file
 * This file contains methods to manage a list of them
 *		including definitions of the base and static elements
 */
#include "ecah.h"
#include "e_card.h"
#include "d_coment.h"
#include "error.h"
#include "declare.h"
/*--------------------------------------------------------------------------*/
//	CARD*	CARD::insertbefore(CARD* before);
//	CARD*	CARD::insertafter(CARD* after);
//	void	CARD::unlink();
/*--------------------------------------------------------------------------*/
CARD* CARD::rootcard = new DEV_COMMENT;
CARD* CARD::putbefore = NULL;
/*--------------------------------------------------------------------------*/
CARD* CARD::insertbefore(CARD* before)
{
  assert(prevcard == this);  // not already linked
  assert(nextcard == this);
  if (before){
    prevcard = before->prev();
    nextcard = before;
  }
  nextcard->prevcard = prevcard->nextcard = this;

  if (stprev){
    stnext = stprev->stnext;
  }else if (stnext){
    stprev = stnext->stprev;
  }else{ /* make self link */
    stprev = stnext = this;
  }
  stnext->stprev = stprev->stnext = this;
  return this;
}    
/*--------------------------------------------------------------------------*/
CARD* CARD::insertafter(CARD* after)
{
  assert(prevcard == this);  // not already linked
  assert(nextcard == this);
  if (after){
    nextcard = after->next();
    prevcard = after;
  }
  nextcard->prevcard = prevcard->nextcard = this;

  if (stprev){
    stnext = stprev->stnext;
  }else if (stnext){
    stprev = stnext->stprev;
  }else{ /* make self link */
    stprev = stnext = this;
  }
  stnext->stprev = stprev->stnext = this;
  return this;
}    
/*--------------------------------------------------------------------------*/
/* unlinkbranch: unlink a branch from parts list
 * doesn't free memory, just unlinks it
 * returns count actually unlinked (either 1 or 0)
 * updates pointers, first, last, etc.
 * so list is consistent on return
 */
void CARD::unlink()
{
  assert(nextcard);
  assert(prevcard);
  assert(stnext);
  assert(stprev);
  nextcard->prevcard = prevcard;
  prevcard->nextcard = nextcard;
  stnext->stprev = stprev;
  stprev->stnext = stnext;
  nextcard = prevcard = stnext = stprev = this;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
