/* error.c
 $Header: /al/acs/src/RCS/io_error.cc,v 7.77 95/03/25 13:53:13 al Exp $
 * Error handler.
 * Collection of functions to handle all types of errors
 * including user interrupts, system errors, overflow, etc.
 */
#include "ecah.h"
#include "ap.h"
#include "error.h"
#include "io.h"
#include "u_option.h"
#include <signal.h>
#include "declare.h"
/*--------------------------------------------------------------------------*/
	void	error(int,const char*,...);
/*--------------------------------------------------------------------------*/
extern jmp_buf envp;
/*--------------------------------------------------------------------------*/
/* error: error message printer
 * print it, if severe enough
 * terminate command, if really bad
 */
void error(int badness, const char *fmt, ...)
{
 char buffer[BIGBUFLEN];
 va_list arg_ptr;

 if (badness >= OPT::picky) {
    va_start(arg_ptr,fmt);
    vsprintf(buffer,fmt,arg_ptr);
    va_end(arg_ptr);
    mputs(buffer,IO::mstderr);
 }
 if (badness >= bDISASTER)
    abort();
 if (badness >= bEXIT)
    exit(badness);
 if (badness >= bERROR)
    longjmp(envp,1);
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
