/* options.cc
 $Header: /al/acs/src/RCS/u_option.cc,v 7.31 95/01/13 02:08:23 al Exp $
 * all the options set by the .options card. -- initialization
 */
#include "ecah.h"
#include "error.h"
#include "u_option.h"

int	OPT::acct = NO;
int	OPT::list = NO;
int	OPT::nomod = NO;
int	OPT::page = NO;
int	OPT::node = NO;
int	OPT::opts = NO;
double	OPT::gmin = 1e-12;
double	OPT::reltol = .001;
double	OPT::abstol = 1e-12;
double	OPT::vntol = 1e-6;
double	OPT::trtol = 7.0;
double	OPT::chgtol = 1e-14;
double	OPT::pivtol = 1e-13;
double	OPT::pivrel = 1e-3;
int	OPT::numdgt = 4;
double	OPT::tnom = 300.0;
int	OPT::cptime = 30000;
int	OPT::limtim = 2;
int	OPT::limpts = 201;
int	OPT::lvlcod = 2;
int	OPT::lvltim = 2;
int	OPT::method = mTRAPEZOID;
int	OPT::maxord = 2;
double	OPT::defl = 100e-6;
double	OPT::defw = 100e-6;
double	OPT::defad = 0.;
double	OPT::defas = 0.;

int	OPT::seed = 1;
double	OPT::wczero = 1e-9;
double	OPT::damp = 0.99;
double	OPT::floor = 1e-20;
double	OPT::tempamb = 300.0;
double	OPT::shortckt = 10e-6;
int	OPT::picky = bPICKY;
int	OPT::inwidth = 80;
int	OPT::outwidth = 80;
double	OPT::xdivisions = 4.;
double	OPT::ydivisions = 4.;
int	OPT::order = oAUTO;
int	OPT::mode = mMIXED;
int	OPT::transits = 2;
int	OPT::dupcheck = NO;
int	OPT::bypass = YES;
int	OPT::incmode = YES;
int	OPT::lubypass = YES;
double	OPT::limit = 1e10;
double	OPT::vmax = 1e10;
double	OPT::vmin = -1e10;
double	OPT::dtmin = 1e-12;
double	OPT::dtratio = 1e9;
int	OPT::rstray = NO;
int	OPT::cstray = YES;
int	OPT::harmonics = 9;
double	OPT::trstepgrow = 2.;
double	OPT::trstepshrink = 8.;
double	OPT::trreject = .5;
int	OPT::showall = NO;
int	OPT::foooo = 0;
int	OPT::diodeflags  = 0;
int	OPT::mosflags = 0;

double	OPT::lowlim = 1. - OPT::reltol;
double	OPT::uplim = 1. + OPT::reltol;

int	OPT::itl[ITL_COUNT] = { 
		100,	// 0=dummy
		100,	// 1=dc (bias) iteration limit
		50, 	// 2=dc transfer iteration limit
		4,	// 3=lower transient iteration limit
		10,	// 4=upper transient iteration limit
		5000,	// 5=transient total iterations allowed
		0,	// 6=source stepping iteration limit
		1,	// 7=worst case iteration limit
		99	// 8=trace nonconvergence start iteration
};
